<?php if (!defined('PmWiki')) exit();
# Addon 'skinnice' defining interactively skin parameters for PmWiki
# Author Pierre Rouzeau - experimental release 0.5 - 27 april 2005
# License GNU GPL V2 and over
# all files *.skt goes in pub/css directory
# file Main.SkinConfig goes in wikilib.d directory. Can be renamed.
# file skinnice.php go in cookbook directory
# file Main.SkinConfig.php go in local directory. Beware to change
# the password in this file, default 'mypassword'.
# To set background images, you need to activate uploads.
#
# pub/css directory should be writable
# local.css apply to all the wiki. A css file applicable to one group
# should be named 'MyGroup.css' and to a page 'AGroup.OnePage.css'
# file.skc contains data to rebuild the css file
# file.skt contains all or only part of what is in a .skc file but
# can be loaded as a template.

$HandleActions['skinconf'] = 'Handleskinconf';  
Markup('skinnice', 'directives', '/\\(:skinnice:\\)/e',"Keep(CreSkinForm())");

XLSDV('en',array(
  'SKNwarn' => 'After [Ok] hit browser reload button to see modifications'
 ));

function InitSkinCf () {
  global $SkinCf;
  $SkinCf ['bgtext']= array (1=>'#f6f6f6',1,'$[Text]','#wikibody');
  $SkinCf ['bgleft']= array (1=>'#f0f0f0',1,'$[Left]','#wikileft');
  $SkinCf ['bgtop']= array (1=>'#e6e6e6',1,'$[Top]','body');
  $SkinCf ['bgleftitle']= array (1=>'#d6d6d6',1,'$[Left title]','#wikileft h1');
  $SkinCf ['bglink']= array (1=>'#ffffdd',1,'$[Link]','body a:hover');
  $SkinCf ['bgleftlink']= array (1=>'#ffffdd',1,'$[Left link]','#wikileft a:hover');
  $SkinCf ['cltext']= array (1=>'#000000',6,'$[Text]','body');
  $SkinCf ['cltitle']= array (1=>'#303030',6,'$[Title]','#wikititle a');
  $SkinCf ['cllink']= array (1=>'#202020',6,'$[Link]','body a');
  $SkinCf ['cloption']= array (1=>'#505050',6,'$[Option]','#wikileft a');  
  $SkinCf ['sztext']= array (1=>'100%',2,'$[Text]','body');
  $SkinCf ['szleft']= array (1=>'90%',2,'$[Left]','#wikileft');
  $SkinCf ['szcmds']= array (1=>'90%',2,'$[Commands]','#wikicmds');
  $SkinCf ['szfoot']= array (1=>'90%',2,'$[Footer]','#wikifoot');  
  $SkinCf ['sztitle']= array (1=>'132%',2,'$[Title]','.pagetitle');  
  $SkinCf ['szh1']= array (1=>'132%',2,'$[Header 1]','h1');
  $SkinCf ['szh2']= array (1=>'124%',2,'$[Header 2]','h2');
  $SkinCf ['szh3']= array (1=>'116%',2,'$[Header 3]','h3');
  $SkinCf ['szh4']= array (1=>'108%',2,'$[Header 4]','h4');
  $SkinCf ['fftext']= array (1=>'sans-serif',3,'$[Text]','body');
  $SkinCf ['lhtext']= array (1=>'120%',4,'$[Text]','body');
  $SkinCf ['bgimgtop']= array (1=>'',5,'$[Top/body]','body');
  $SkinCf ['bgimgleft']= array (1=>'',5,'$[Left]','#wikileft');
  $SkinCf ['bgimgtext']= array (1=>'',5,'$[Text]','#wikibody');
  $SkinCf ['sidemrgl']= array (1=>'8px',7,'$[Side margin]','#wikileft');  
  $SkinCf ['sidemrgr']= array (1=>'8px',8,'$[Side margin]','#wikibody');  
  $SkinCf ['perso']= array (1=>'',10,'$[Personal wiki (hide stuff)]','');
  $SkinCf ['rcalt']= array (1=>'',10,'$[Recent change alternative]','');
  foreach ($SkinCf as $key=>$dt) $SkinCf[$key][5] = $dt[1];
}

function readskinconf ($fconf) {
  global $SkinCf;
  clearstatcache();
  if (file_exists ($fconf)) {
    $fp = fopen($fconf, "rb");
    $contents = fread ($fp, filesize ($fconf));
    if (preg_match_all('/([a-z]+):(\\S+)/', $contents, $match)) {
	  $i = 0;
      foreach($match[1] as $e) {
        $SkinCf[$e][1] = $match[2][$i++];
      }
    }
    fclose($fp);
  }
}
 
function CreSkinForm() {
  global $SkinCf, $ScriptUrl, $FarmD, $pagename, $tfilefmt,
  $GroupPattern,$NamePattern,$EnableSknWrite;
  InitSkinCf();
  $pagelist = ListPages();
  $grouplist = array();
  foreach($pagelist as $pname) {
    if (!preg_match("/^($GroupPattern)[\\/.]($NamePattern)$/",$pname,$m))
      continue;
    $grouplist[$m[1]]=$m[1];
  }
  natsort($grouplist);
  $cgroup = @$_REQUEST['apply'];
  $cl = @$_REQUEST['color'];
  $clr = sprintf("%06x",$cl);
  
  $msg = @$_REQUEST['msg'];
  if ($msg!='') {
    if ($msg{0}=='#') $msg = "<span style='color:red;'>$msg</span>";
    $msg = "<h3>$msg</h3>";
  }
  else $msg = '<br/>';
  $sel = ('_'==$cgroup) ? 'selected' : ''; 
  $selgroup = "<select name='apply'>\n<option value=''>\n<option $sel value='_'>$[WHOLE WIKI]\n";
  foreach($grouplist as $g=>$t) {
    $sel = ($g==$cgroup) ? 'selected' : ''; 
    $selgroup .="<option $sel value='$g'>$t";
  }
  $selgroup .= "</select>";
  $cssdir = "$FarmD/pub/css"; 
  $fconf = "$cssdir/local.skc";
  $hlf="<br class='halfv' />";
  readskinconf ($fconf);
  $chkperso = ($SkinCf['perso'][1]!='') ? 'checked' : '';
  $chkrcalt = ($SkinCf['rcalt'][1]!='') ? 'checked' : '';  
  $Frm = "<form enctype='multipart/form-data' action='$ScriptUrl' method='post'>
  <input type='hidden' name='pagename' value='$pagename' />
  <input type='hidden' name='action' value='skinconf' />
  <input type='hidden' name='sidemrgr' value='{$SkinCf['sidemrgr'][1]}' />   
  <input type='hidden' name='sidemrgl' value='{$SkinCf['sidemrgl'][1]}' />   
  $[Apply to]:\n$selgroup &nbsp; &nbsp;
  <input type='submit' name='ok' value=' $[Save as] ' />  
  <input name='fname' size='12' value='' />$hlf$msg
  <table width = '100%' border='0' cellspacing='0'><tr><td colspan='2'>
  <input type='submit' name='ok' value='    $[Ok]    ' />
  <input type='submit' name='default' value=' $[Default] ' />&nbsp; &nbsp; &nbsp;
  <input type='submit' name='cchart' value='$[Color chart]' />
  <input type='submit' name='cchart2' value='$[Light color]' />
  <span style='background-color:#$clr;' >&nbsp; &nbsp;</span>&nbsp; #$clr
  <br/>$hlf$[SKNwarn]<br />
  </td></tr><tr><td valign='top'>$hlf
  <input type='checkbox' name='perso' value='perso' $chkperso>{$SkinCf['perso'][3]}
  <h4>$[Existing styles]</h4>\n".SkOptionDir($cssdir, 'skt', 'tmpl')."
  <h4>$[Font family]</h4>\n".InputSkCf(3)." 
  <h4>$[Font size]</h4>\n".InputSkCf(2)."
  <h4>$[Line height]</h4>\n".InputSkCf(4)."</td><td valign='top'>$hlf
  <input type='checkbox' name='rcalt' value='perso' $chkrcalt />{$SkinCf['rcalt'][3]}<br />
  <h4>$[Text color]</h4>\n".InputSkCf(6)."
  <h4>$[Background color]</h4>\n".InputSkCf(1)."
  <h4>$[Background image]</h4>\n".InputSkCf(5)."
  <span style='color: red;'><h1>$[Header 1]</h1><h2>$[Header 2]</h2>
  <h3>$[Header 3]</h3><h4>$[Header 4]</h4></span>
  </td></tr></table></form>";
  $Frm = preg_replace('/\\$\\[(?>([^\\]]+))\\]/e',"XL(PSS('$1'))",$Frm); // Handle translation
  $ftmpl = $FarmD."/pub/skins/pmwiki/pmwiki.tmpl";
  if ((file_exists ($ftmpl)) and (IsEnabled($EnableSknWrite,0))) {
    $k = implode('',file($ftmpl));
    $exc= '<td id=\'wikititle\'>
   	<div class=\'pagegroup\'><a href=\'$ScriptUrl/$Group\'>$Group</a> 
	<div id=\'wikirch2\'><a href=\'$ScriptUrl/$[$Group/RecentChanges]\' title=\'$[Group recent changes]\'> _&Delta;_ </a></div> /</div>
	<div class=\'pagetitle\'><a href=\'$PageUrl\'>$Title</a></div></td>
	<td id=\'wikicmds\'>
	<div id=\'wikirch\'><a href=\'$ScriptUrl/$[$Group/RecentChanges]\'>$[Recent Changes]</a></div>
	<a href=\'$PageUrl?action=print\' target=\'_blank\'>$[Printable View]</a>
	<div id=\'wikicmds2\'><a href=\'$PageUrl?action=diff\'>$[Page History]</a>
	<a href=\'$PageUrl?action=edit\'>$[Edit Page]</a></div></td></tr></table>
';
    if (!ereg ('kirch', $k)){
      $chang= preg_replace('/<td id=\'wikiti(.*)(?=<!--PageTex)/sm', $exc, $k);
	  $fp = fopen($ftmpl, "wb");
      fwrite($fp, $chang);
      fclose($fp);
	}  
  } 
  return ($Frm);
}
//style=\'display:none\'

function InputSkCf ($type, $width=9) {
	global $SkinCf, $UploadDir, $UploadPrefixFmt, $pagename;
	$SkFontFam = array ('inherit'=>'$[User default]', 'serif'=>'$[Serif]',
		'sans-serif'=>'$[Sans-serif]', 'cursive'=>'$[Cursive]');	
	$SkImgExt = 'jpg|jpeg|gif|png|GIF|PNG|JPG|JPEG';	
	$Frmx = '';
	if ($type==5)
		$uploaddir = FmtPageName("$UploadDir$UploadPrefixFmt", $pagename);
	foreach ($SkinCf as $key=>$dt) {
		if ($dt[2]==$type) {
			switch ($type) {
			case 1: //bg color
			case 2: //font-size
			case 4: //line-height 
			case 6: //color
				$Frmx .= "<input name='$key' size='$width' value='".$dt[1]."' /> &nbsp;".
					$dt[3]." - $[def]: ".$dt[5]."<br />\n";
				break;
			case 3: // font-family
				foreach ($SkFontFam as $fam=>$famtxt) {
					if ($fam==$SkinCf[$key][1]) $chk = 'checked'; else $chk='';
					$Frmx .= "<input type='radio' name='fftext' value='$fam' $chk>$famtxt<br />\n";
				}
				break;
			case 5: // bg image
				$Frmx .= SkOptionDir($uploaddir, $SkImgExt, $key, $dt[1])." &nbsp;{$dt[3]}<br />";
				break;
			}
		}
	}
	return $Frmx;
}

function SkOptionDir($dir, $select, $name, $value = '') {
	if ($handle = @opendir($dir)) { 
		$tmpl = "<select name='$name'><option>";
		while (false !== ($file = readdir($handle))) {
			if ($file == $value) $sel= ' selected'; else $sel='';
			if (ereg("((.+)\.($select))$", $file))
				$tmpx[] = "\n<option$sel>$file"; 
		}
		closedir($handle);
		natsort ($tmpx);
		$tmpl .= implode ('', $tmpx);
		$tmpl .= "</select>";
	}
	else $tmpl = "";
	return $tmpl;
}

function Handleskinconf($pagename) {
  global $SkinCf, $FarmD, $UploadUrlFmt, $UploadPrefixFmt, $pagename, $EnableSave;
  $SkCssPar = array(1=>'background-color','font-size','font-family','line-height',
		'background-image','color','padding-left','padding-right');		
  InitSkinCf();
  foreach ($SkinCf as $key=>$dt) $SkinCf[$key][1] = ChkData($key);
  $cssdir = "$FarmD/pub/css"; 
  $def = @$_REQUEST['tmpl'];
  if ($def!='') readskinconf ("$cssdir/$def"); // read predefined style file
  if (isset($_POST["default"])) 
    foreach ($SkinCf as $key=>$dt) $SkinCf[$key][1] = $dt[5];
  mkdirp($cssdir);
  fixperms($cssdir); // If already existing
  $fcfname = "$cssdir/local.skc";
  $fp = fopen($fcfname, "wb");  
  foreach ($SkinCf as $key=>$dt) { 
    fwrite($fp,"$key:{$dt[1]}\n");
	$SkArea[] = $dt[4];
  }	
  fclose($fp);
  $name = @$_REQUEST['fname'];
  if (($name!='') and (IsEnabled($EnableSave,1))) {
    $name = preg_replace ("/\.skt$/","",$name);
    $fconf = "$cssdir/$name.skt"; 
	if (!copy($fcfname, $fconf))
      $msg = "#$[Creation of file failed]: $name.skt";
	else
	  $msg = "$[Datas saved in file]: $name.skt";
  }	  
  $SkArea = array_unique ($SkArea);
  $uploadurl = FmtPageName("$UploadUrlFmt$UploadPrefixFmt", $pagename);
  $css = '';
  foreach ($SkArea as $area) {
    if ($area!='') {
      $css .=$area." {\n";
	  foreach ($SkinCf as $key=>$dt){
	    if (($area==$dt[4]) and ($dt[1]!='')) {
	      $css .= $SkCssPar[$dt[2]];
		  if ($SkCssPar[$dt[2]]=='background-image')
		    $css .= ":url('$uploadurl/{$dt[1]}');\n";
		  else 
		    $css .= ":{$dt[1]};\n";
	    }
	  }
	  $css .="}\n";
	}
  }
  if ($SkinCf['rcalt'][1]!='')
    $css .= "#wikirch{display:none}\n#wikirch2{display:inline}";
  else 
    $css .= "#wikirch2{display:none}\n#wikirch{display:inline}";
  if ($SkinCf['perso'][1]!='') {
    $css .= ".footnav {color:{$SkinCf['bgtop'][1]}; font-size:80%}\n".
      ".footnav a{color:{$SkinCf['bgtop'][1]}}\n".
      "#wikirch, #wikirch2, #wikicmds2 {display:none}\n";
  }
  $css .= "
body {margin:4px 0px}
#wikilogo {margin-left: 12px}
#wikileft a{
 margin: 1px;
 text-decoration:none; 
 border-bottom: 1px solid #aaaaaa;
 width:100%;
 display:block; 
}
#wikicmds a{
 color:{$SkinCf['cloption'][1]};
 text-decoration:none 
}
.pagetitle{margin:6px 0px}
.halfv{line-height:0.5em}
h3{margin:20px 0px}
h4{margin:16px 0px}
#wikifoot{padding-left:12px}
#wikihead{padding-right:12px}
";
  $fpage = "$cssdir/$pagename.css";
  $fp = fopen($fpage, "wb");
  fwrite($fp, $css);
  fclose($fp);
  $cgroup = @$_REQUEST['apply'];
  if (($cgroup != '') and (IsEnabled($EnableSave,1))) {
    if ($cgroup == '_') copy ($fpage, "$cssdir/local.css");
	else copy ($fpage, "$cssdir/$cgroup.css");
  }
  clearstatcache();
  if (isset($_POST["cchart"])) colorchart (24,0);
  if (isset($_POST["cchart2"])) colorchart (8,160);
  sleep(1);
  Redirect($pagename,"\$PageUrl?msg=$msg&apply=$cgroup");
}  

function colorchart ($delta, $limit){
  global $pagename, $PageStartFmt;
  $addr = FmtPageName('$PageUrl',$pagename);
  $PageChartFmt =
"<html><head><style type='text/css'><!--#ilk a{text-decoration:none}--></style></head>
<body><center>".XL(PSS('Click on color to select'))."<br/><br/>
<script language='JavaScript'><!--
for (i=255;i>=$limit;i=i-$delta) { 
document.write('<table id=\"ilk\" border=0 cellpadding=0>');
for (j=255;j>=$limit;j=j-$delta) {
document.write('<tr>');
for (k=255;k>=$limit;k=k-$delta) {
document.write('<td style=\"background-color:rgb('+i+','+j+','+k+');\">');
cl=65536*i+256*j+k;
document.write('<a href=\"$addr?color='+cl+'\">&nbsp; &nbsp; &nbsp; &nbsp;</a></td>'); }
document.write('</tr>'); }
document.write('</table><br>'); }
// end --></script></center></body></html>";
  print ($PageChartFmt);  
  exit;
}

function ChkData ($varname) {
	global $SkinCf;
	$text = @$_REQUEST[$varname];
	$type = $SkinCf[$varname][2];
	if ($type==1) { // color
		$text = strtolower(trim($text));
		if ($text=='none') return $text; // to set empty color
		$valid = ereg ("([0-9a-f]{6})", $text, $regs);
		$text = '#'.$regs[1];
	}
	else if (($type==2) or ($type==4)) { // size - line-height (%)
		$valid = ereg ("([1-9][0-9][0-9]?)", $text, $regs);  
		$text = $regs[1].'%';
	}
	else return $text;
	if (!$valid) $text = $SkinCf[$varname][5];
	# todo : some treatment to set error in variable and display later on
	return $text;
}

/* debug function 
function dbs($par) {
	$fp = fopen('errorskinconf.txt', "a+b");
	fwrite($fp, "\n$par");
	fclose($fp);
}
*/